Package ghidra.program.model.data

# Interface AnnotationHandler

All Superinterfaces:
  `ExtensionPoint`

All Known Implementing Classes:
  `DefaultAnnotationHandler`

public interface AnnotationHandler extends ExtensionPoint
NOTE: ALL AnnotationHandler CLASSES MUST END IN "AnnotationHandler". If not, the ClassSearcher will not find them. AnnotationHandlers provide prefix/suffix information for various datatypes for specific C-like languages.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the specific handler
  `String[]`
  `getFileExtensions()`
  Returns an array of known extensions for the output file type.
  `String`
  `getLanguageName()`
  Returns the name of the C-like language that this handler supports
  `String`
  `getPrefix(Composite c, DataTypeComponent dtc)`
  Returns the prefix for type Composite
  `String`
  `getPrefix(Enum e, String member)`
  Returns the prefix for type Enum
  `String`
  `getSuffix(Composite c, DataTypeComponent dtc)`
  Returns the suffix for type Composite
  `String`
  `getSuffix(Enum e, String member)`
  Returns the suffix for type Enum
  `String`
  `toString()`
  Returns a string description of this handler.

- ## Method Details

  - ### getPrefix

    String getPrefix(Enum e, String member)
    Returns the prefix for type Enum
    Parameters:
      `e` - the Enum datatype
      `member` - the name of the member of the Enum
    Returns:
      the prefix for type Enum

  - ### getSuffix

    String getSuffix(Enum e, String member)
    Returns the suffix for type Enum
    Parameters:
      `e` - the Enum datatype
      `member` - the name of the member of the Enum
    Returns:
      the suffix for type Enum

  - ### getPrefix

    String getPrefix(Composite c, DataTypeComponent dtc)
    Returns the prefix for type Composite
    Parameters:
      `c` - the Composite datatype
      `dtc` - the name of the member of the Composite
    Returns:
      the prefix for type Composite

  - ### getSuffix

    String getSuffix(Composite c, DataTypeComponent dtc)
    Returns the suffix for type Composite
    Parameters:
      `c` - the Composite datatype
      `dtc` - the name of the member of the Composite
    Returns:
      the suffix for type Composite

  - ### getDescription

    String getDescription()
    Returns the description of the specific handler
    Returns:
      the description of the specific handler

  - ### getLanguageName

    String getLanguageName()
    Returns the name of the C-like language that this handler supports
    Returns:
      the name of the C-like language that this handler supports

  - ### getFileExtensions

    String[] getFileExtensions()
    Returns an array of known extensions for the output file type. If no extensions are preferred, the an empty array should be returned.
    Returns:
      an array of known extensions for the output file type.

  - ### toString

    String toString()
    Returns a string description of this handler.
    Overrides:
      `toString` in class `Object`
    Returns:
      a string description of this handler